export declare const Container: {
    fontFamily: string;
    fontWeight: string;
};
export declare const FormContainer: {
    textAlign: string;
    marginTop: string;
    margin: string;
};
export declare const FormSection: {
    position: string;
    marginBottom: string;
    backgroundColor: string;
    padding: string;
    textAlign: string;
    display: string;
    minWidth: string;
    borderRadius: string;
    boxShadow: string;
};
export declare const FormField: {
    marginBottom: string;
};
export declare const SectionHeader: {
    color: string;
    marginBottom: string;
    fontSize: string;
    fontWeight: string;
};
export declare const SectionBody: {
    marginBottom: string;
};
export declare const SectionFooter: {
    fontSize: string;
    color: string;
    display: string;
    flexDirection: string;
    alignItems: string;
};
export declare const SectionFooterPrimaryContent: {
    marginLeft: string;
};
export declare const SectionFooterSecondaryContent: {
    marginRight: string;
    alignSelf: string;
};
export declare const Input: {
    display: string;
    width: string;
    padding: string;
    fontSize: string;
    fontFamily: string;
    color: string;
    backgroundColor: string;
    backgroundImage: string;
    border: string;
    borderRadius: string;
    boxSizing: string;
    marginBottom: string;
};
export declare const Button: {
    minWidth: string;
    display: string;
    marginBottom: string;
    fontSize: string;
    fontWeight: number;
    lineHeight: string;
    textAlign: string;
    whiteSpace: string;
    verticalAlign: string;
    touchAction: string;
    cursor: string;
    userSelect: string;
    backgroundImage: string;
    color: string;
    backgroundColor: string;
    borderColor: string;
    textTransform: string;
    padding: string;
    letterSpacing: string;
    border: string;
};
export declare const SignInButton: {
    position: string;
    width: string;
    borderRadius: string;
    marginBottom: string;
    cursor: string;
    padding: number;
    fontFamily: string;
    color: string;
    fontSize: string;
    '#google_signin_btn': {
        backgroundColor: string;
        fontFamily: string;
        border: string;
    };
    '#facebook_signin_btn': {
        backgroundColor: string;
        borderColor: string;
    };
    '#amazon_signin_btn': {
        backgroundColor: string;
        border: string;
    };
};
export declare const SignInButtonIcon: {
    position: string;
    left: number;
    '#google_signin_btn_icon': {
        backgroundColor: string;
        borderRadius: string;
        height: string;
        width: string;
        padding: string;
    };
    '#facebook_signin_btn_icon': {
        height: string;
        width: string;
        padding: string;
    };
    '#amazon_signin_btn_icon': {
        padding: string;
        height: string;
        width: string;
    };
};
export declare const SignInButtonContent: {
    display: string;
    padding: string;
    whiteSpace: string;
    overflow: string;
    textOverflow: string;
    textAlign: string;
};
export declare const Strike: {
    width: string;
    textAlign: string;
    borderBottom: string;
    lineHeight: string;
    margin: string;
    color: string;
};
export declare const StrikeContent: {
    background: string;
    padding: string;
    fontSize: string;
    fontWeight: string;
};
export declare const ActionRow: {
    marginBottom: string;
};
export declare const FormRow: {
    marginBottom: string;
};
export declare const A: {
    color: string;
    cursor: string;
};
export declare const Hint: {
    color: string;
    fontSize: string;
};
export declare const Radio: {
    marginRight: string;
    verticalAlign: string;
};
export declare const InputLabel: {
    color: string;
    fontSize: string;
    marginBottom: string;
};
declare const Bootstrap: {
    container: {
        fontFamily: string;
        fontWeight: string;
    };
    formContainer: {
        textAlign: string;
        marginTop: string;
        margin: string;
    };
    formSection: {
        position: string;
        marginBottom: string;
        backgroundColor: string;
        padding: string;
        textAlign: string;
        display: string;
        minWidth: string;
        borderRadius: string;
        boxShadow: string;
    };
    formField: {
        marginBottom: string;
    };
    sectionHeader: {
        color: string;
        marginBottom: string;
        fontSize: string;
        fontWeight: string;
    };
    sectionBody: {
        marginBottom: string;
    };
    sectionFooter: {
        fontSize: string;
        color: string;
        display: string;
        flexDirection: string;
        alignItems: string;
    };
    sectionFooterPrimaryContent: {
        marginLeft: string;
    };
    sectionFooterSecondaryContent: {
        marginRight: string;
        alignSelf: string;
    };
    input: {
        display: string;
        width: string;
        padding: string;
        fontSize: string;
        fontFamily: string;
        color: string;
        backgroundColor: string;
        backgroundImage: string;
        border: string;
        borderRadius: string;
        boxSizing: string;
        marginBottom: string;
    };
    button: {
        minWidth: string;
        display: string;
        marginBottom: string;
        fontSize: string;
        fontWeight: number;
        lineHeight: string;
        textAlign: string;
        whiteSpace: string;
        verticalAlign: string;
        touchAction: string;
        cursor: string;
        userSelect: string;
        backgroundImage: string;
        color: string;
        backgroundColor: string;
        borderColor: string;
        textTransform: string;
        padding: string;
        letterSpacing: string;
        border: string;
    };
    signInButton: {
        position: string;
        width: string;
        borderRadius: string;
        marginBottom: string;
        cursor: string;
        padding: number;
        fontFamily: string;
        color: string;
        fontSize: string;
        '#google_signin_btn': {
            backgroundColor: string;
            fontFamily: string;
            border: string;
        };
        '#facebook_signin_btn': {
            backgroundColor: string;
            borderColor: string;
        };
        '#amazon_signin_btn': {
            backgroundColor: string;
            border: string;
        };
    };
    signInButtonIcon: {
        position: string;
        left: number;
        '#google_signin_btn_icon': {
            backgroundColor: string;
            borderRadius: string;
            height: string;
            width: string;
            padding: string;
        };
        '#facebook_signin_btn_icon': {
            height: string;
            width: string;
            padding: string;
        };
        '#amazon_signin_btn_icon': {
            padding: string;
            height: string;
            width: string;
        };
    };
    signInButtonContent: {
        display: string;
        padding: string;
        whiteSpace: string;
        overflow: string;
        textOverflow: string;
        textAlign: string;
    };
    formRow: {
        marginBottom: string;
    };
    strike: {
        width: string;
        textAlign: string;
        borderBottom: string;
        lineHeight: string;
        margin: string;
        color: string;
    };
    strikeContent: {
        background: string;
        padding: string;
        fontSize: string;
        fontWeight: string;
    };
    actionRow: {
        marginBottom: string;
    };
    a: {
        color: string;
        cursor: string;
    };
    hint: {
        color: string;
        fontSize: string;
    };
    radio: {
        marginRight: string;
        verticalAlign: string;
    };
    inputLabel: {
        color: string;
        fontSize: string;
        marginBottom: string;
    };
};
export default Bootstrap;
