export declare const Container: {
    fontFamily: string;
    fontWeight: string;
    lineHeight: string;
    color: string;
    textAlign: string;
    paddingLeft: string;
    paddingRight: string;
};
export declare const NavBar: {
    position: string;
    border: string;
    borderColor: string;
};
export declare const NavRight: {
    textAlign: string;
};
export declare const Nav: {
    margin: string;
};
export declare const NavItem: {
    display: string;
    padding: string;
    lineHeight: string;
};
export declare const NavButton: {
    display: string;
    padding: string;
    marginTop: string;
    marginBottom: string;
    fontSize: string;
    fontWeight: number;
    lineHeight: string;
    textAlign: string;
    whiteSpace: string;
    verticalAlign: string;
    touchAction: string;
    cursor: string;
    userSelect: string;
    backgroundImage: string;
    border: string;
    borderRadius: string;
    color: string;
    backgroundColor: string;
    borderColor: string;
};
export declare const FormContainer: {
    textAlign: string;
};
export declare const FormSection: {
    marginBottom: string;
    backgroundColor: string;
    border: string;
    borderRadius: string;
    textAlign: string;
    width: string;
    display: string;
};
export declare const ErrorSection: {
    marginBottom: string;
    color: string;
    backgroundColor: string;
    border: string;
    borderRadius: string;
    textAlign: string;
};
export declare const SectionHeader: {
    color: string;
    backgroundColor: string;
    borderColor: string;
    padding: string;
    borderBottom: string;
    borderTopLeftRadius: string;
    borderTopRightRadius: string;
    textAlign: string;
};
export declare const SectionFooter: {
    color: string;
    backgroundColor: string;
    padding: string;
    borderTop: string;
    borderTopLeftRadius: string;
    borderTopRightRadius: string;
};
export declare const SectionBody: {
    padding: string;
};
export declare const FormRow: {
    marginBottom: string;
};
export declare const ActionRow: {
    marginBottom: string;
};
export declare const Input: {
    display: string;
    width: string;
    height: string;
    padding: string;
    fontSize: string;
    lineHeight: string;
    color: string;
    backgroundColor: string;
    backgroundImage: string;
    border: string;
    borderRadius: string;
    boxShadow: string;
    boxSizing: string;
    transition: string;
};
export declare const Button: {
    display: string;
    padding: string;
    marginBottom: string;
    fontSize: string;
    fontWeight: number;
    lineHeight: string;
    textAlign: string;
    whiteSpace: string;
    verticalAlign: string;
    touchAction: string;
    cursor: string;
    userSelect: string;
    backgroundImage: string;
    border: string;
    borderRadius: string;
    color: string;
    backgroundColor: string;
    borderColor: string;
};
export declare const SignInButton: {
    position: string;
    padding: string;
    fontSize: string;
    textAlign: string;
    whiteSpace: string;
    overflow: string;
    textOverflow: string;
    display: string;
    width: string;
    marginTop: string;
    '#google_signin_btn': {
        color: string;
        backgroundColor: string;
        borderColor: string;
    };
    '#facebook_signin_btn': {
        color: string;
        backgroundColor: string;
        borderColor: string;
    };
};
export declare const Space: {
    display: string;
    width: string;
};
export declare const A: {
    color: string;
    cursor: string;
};
export declare const Pre: {
    overflow: string;
    fontFamily: string;
    display: string;
    padding: string;
    margin: string;
    fontSize: string;
    lineHeight: string;
    color: string;
    wordBreak: string;
    wordWrap: string;
    backgroundColor: string;
    border: string;
    borderRadius: string;
};
export declare const Col1: {
    display: string;
    width: string;
};
export declare const Col2: {
    display: string;
    width: string;
};
export declare const Col3: {
    display: string;
    width: string;
};
export declare const Col4: {
    display: string;
    width: string;
};
export declare const Col5: {
    display: string;
    width: string;
};
export declare const Col6: {
    display: string;
    width: string;
};
export declare const Col7: {
    display: string;
    width: string;
};
export declare const Col8: {
    display: string;
    width: string;
};
export declare const Col9: {
    display: string;
    width: string;
};
export declare const Col10: {
    display: string;
    width: string;
};
export declare const Col11: {
    display: string;
    width: string;
};
export declare const Col12: {
    display: string;
    width: string;
};
export declare const Hidden: {
    display: string;
};
export declare const Bootstrap: {
    container: {
        fontFamily: string;
        fontWeight: string;
        lineHeight: string;
        color: string;
        textAlign: string;
        paddingLeft: string;
        paddingRight: string;
    };
    navBar: {
        position: string;
        border: string;
        borderColor: string;
    };
    nav: {
        margin: string;
    };
    navRight: {
        textAlign: string;
    };
    navItem: {
        display: string;
        padding: string;
        lineHeight: string;
    };
    navButton: {
        display: string;
        padding: string;
        marginTop: string;
        marginBottom: string;
        fontSize: string;
        fontWeight: number;
        lineHeight: string;
        textAlign: string;
        whiteSpace: string;
        verticalAlign: string;
        touchAction: string;
        cursor: string;
        userSelect: string;
        backgroundImage: string;
        border: string;
        borderRadius: string;
        color: string;
        backgroundColor: string;
        borderColor: string;
    };
    formContainer: {
        textAlign: string;
    };
    formSection: {
        marginBottom: string;
        backgroundColor: string;
        border: string;
        borderRadius: string;
        textAlign: string;
        width: string;
        display: string;
    };
    errorSection: {
        marginBottom: string;
        color: string;
        backgroundColor: string;
        border: string;
        borderRadius: string;
        textAlign: string;
    };
    sectionHeader: {
        color: string;
        backgroundColor: string;
        borderColor: string;
        padding: string;
        borderBottom: string;
        borderTopLeftRadius: string;
        borderTopRightRadius: string;
        textAlign: string;
    };
    sectionBody: {
        padding: string;
    };
    sectionFooter: {
        color: string;
        backgroundColor: string;
        padding: string;
        borderTop: string;
        borderTopLeftRadius: string;
        borderTopRightRadius: string;
    };
    formRow: {
        marginBottom: string;
    };
    actionRow: {
        marginBottom: string;
    };
    space: {
        display: string;
        width: string;
    };
    signInButton: {
        position: string;
        padding: string;
        fontSize: string;
        textAlign: string;
        whiteSpace: string;
        overflow: string;
        textOverflow: string;
        display: string;
        width: string;
        marginTop: string;
        '#google_signin_btn': {
            color: string;
            backgroundColor: string;
            borderColor: string;
        };
        '#facebook_signin_btn': {
            color: string;
            backgroundColor: string;
            borderColor: string;
        };
    };
    input: {
        display: string;
        width: string;
        height: string;
        padding: string;
        fontSize: string;
        lineHeight: string;
        color: string;
        backgroundColor: string;
        backgroundImage: string;
        border: string;
        borderRadius: string;
        boxShadow: string;
        boxSizing: string;
        transition: string;
    };
    button: {
        display: string;
        padding: string;
        marginBottom: string;
        fontSize: string;
        fontWeight: number;
        lineHeight: string;
        textAlign: string;
        whiteSpace: string;
        verticalAlign: string;
        touchAction: string;
        cursor: string;
        userSelect: string;
        backgroundImage: string;
        border: string;
        borderRadius: string;
        color: string;
        backgroundColor: string;
        borderColor: string;
    };
    a: {
        color: string;
        cursor: string;
    };
    pre: {
        overflow: string;
        fontFamily: string;
        display: string;
        padding: string;
        margin: string;
        fontSize: string;
        lineHeight: string;
        color: string;
        wordBreak: string;
        wordWrap: string;
        backgroundColor: string;
        border: string;
        borderRadius: string;
    };
    col1: {
        display: string;
        width: string;
    };
    col2: {
        display: string;
        width: string;
    };
    col3: {
        display: string;
        width: string;
    };
    col4: {
        display: string;
        width: string;
    };
    col5: {
        display: string;
        width: string;
    };
    col6: {
        display: string;
        width: string;
    };
    col7: {
        display: string;
        width: string;
    };
    col8: {
        display: string;
        width: string;
    };
    col9: {
        display: string;
        width: string;
    };
    col10: {
        display: string;
        width: string;
    };
    col11: {
        display: string;
        width: string;
    };
    col12: {
        display: string;
        width: string;
    };
    hidden: {
        display: string;
    };
};
/**
 * @deprecated use named import
 */
export default Bootstrap;
